<?php
/*
 * ==========================================================
 * INFRAPAY WHMCS MODULE
 * ==========================================================
 *
 * � 2024 InfraPay.co. All rights reserved.
 *
 */

if (!defined('WHMCS')) {
    die('This file cannot be accessed directly');
}

function infrapay_MetaData() {
    return array(
        'DisplayName' => 'Infrapay',
        'APIVersion' => '1.2',
        'DisableLocalCreditCardInput' => true,
        'TokenisedStorage' => false,
    );
}

function infrapay_config() {
    global $CONFIG;
    return array(
        'FriendlyName' => array(
            'Type' => 'System',
            'Value' => 'Infrapay',
        ),
        'infrapayURL' => array(
            'FriendlyName' => 'Infrapay URL',
            'Type' => 'text',
            'Size' => '25',
            'Default' => '',
            'Description' => 'Enter the URL of your infrapay admin area, e.g. https://www.infrapay.co/admin.php.',
        ),
        'infrapayKey' => array(
            'FriendlyName' => 'Webhook secret key',
            'Type' => 'password',
            'Size' => '25',
            'Default' => '',
            'Description' => 'Enter the Infrapay webhook secret key. Get it from Infrapay > Settings > Webhook > Webhook secret key.',
        ),
        'cloudKey' => array(
            'FriendlyName' => 'Cloud API key',
            'Type' => 'text',
            'Size' => '25',
            'Default' => '',
            'Description' => 'Enter the Infrapay API key. Get it from Infrapay > Account > API key.',
        ),
        'webhookURL' => array(
            'FriendlyName' => 'Webhook URL',
            'Type' => 'text',
            'Size' => '25',
            'Value' => $CONFIG['SystemURL'] . '/modules/gateways/callback/infrapay.php',
            'Default' => $CONFIG['SystemURL'] . '/modules/gateways/callback/infrapay.php'
        )
    );
}

function infrapay_link($params) {
    $encrypted = localAPI('EncryptPassword', array('password2' => strval($params['invoiceid'])));
    $link = str_replace(['admin.php', '//pay.php'], ['', '/pay.php'], $params['infrapayURL'] . '/pay.php?checkout_id=custom-whmcs&price=' . $params['amount'] . '&currency=' . $params['currency'] . '&external-reference=' . base64_encode(is_string($encrypted) ? $encrypted : $encrypted['password']) . '&redirect=' . urlencode($params['returnurl']) . (trim($params['cloudKey']) ? '&cloud=' . trim($params['cloudKey']) : '') . '&note=' . urlencode('WHMCS invoice ID ' . $params['invoiceid']));
    return strpos($_SERVER['REQUEST_URI'], 'viewinvoice') ? '<a href="' . $link . '" class="btn btn-success btn-sm" id="infrapay-link">' . (!isset($_LANG) || empty($_LANG['PAY_NOW']) ? 'Pay now' : $_LANG['PAY_NOW']) . '</a>' : '<script>document.location = "' . $link . '";</script>';
}